#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <iostream>
#include <stdio.h>
#include <vector>
#include <stack>
#include <ctime>
#include <math.h>
#include <cstring>
#include <stdlib.h>

using namespace std;

struct Point {
  double x;
  double y;

  Point(double a, double b) :x(a), y(b) { };
};

double I(Point p1, Point p2) {
  return max(
      p2.x - p1.x,
      p2.y - p1.y
      );
}

class Set {
public:
  Set (Point p, vector<Point> *A, int a, int b, bool c): point(p), A(A), begin(a), end(b), increasing(!c)  { }

  Point point;
  int begin;
  int end; 
  bool increasing;

  vector<Point> *A;

  void print() {
    #ifdef DEBUG
    cout<<"begin : "<<begin<<" end : "<<end<<" increasing : "<<increasing<<" point (" <<point.x<<", "<<point.y<<") "<<endl;
    if (getSize()>0) {
      for(int a=begin; a<=end; a++) {
        cout<<a<<" : "<<I((*A)[a], point)<<endl;
      }
    }
    #endif
  }

  int getSize() {
    if (begin == -1 || end < begin) {
      return 0;
    } else {
      return end - begin + 1;
    }
  }

  double getElement(int pos) {
    // TODO : different for reverse ?
    if (begin + pos > end) {
      throw "this should never happen";
    }

    // TODO : or the other way around?
    return I((*A)[begin + pos], point);
  }

  virtual void deleteBigger(double d) {
    if (increasing) {

#ifdef DEBUG      
      int E = end;
      int help = end;
      while(help>=begin && I((*A)[help], point) >= d) {
        help--;
      }
#endif
      if(end>=begin && I((*A)[end], point) >= d) {
        int a = begin - 1;
        int b = end;
        while(a + 1 < b) {
          int mid = (a + b) / 2;


          if (I((*A)[mid], point) >= d) {
            b = mid;
          } else {
            a = mid;
          }
        }

        end = b - 1;
      }
#ifdef DEBUG
      if (help != end){
        cout<<"ERROR : "<<help<<" "<<end<<endl;
      } 
#endif
      } else {
#ifdef DEBUG
      int help = begin;

      while(help<=end && I((*A)[help], point) >= d) {
        help++;
      }
#endif
      if(begin<=end && I((*A)[begin], point) >= d) {
        int a = begin;
        int b = end + 1;

        while (a < b) {
          int mid = (a + b) / 2;

          if (I((*A)[mid], point) >= d) {
            a = mid + 1;
          } else {
            b = mid;
          }
        }
        
        begin = b;
      }
#ifdef DEBUG
      if (help != begin) { 
        cout<<" ERROR 2: "<<help<<" "<<begin<<endl;
        throw "error";
      }
#endif
    }
  }

  virtual void deleteSmaller(double d) {
  if (!increasing) {

  #ifdef DEBUG
      int help =end;

      int E = end;
      
      while(help>=begin && I((*A)[help], point) <= d) {
        help--;
      }
#endif
      if(end>=begin && I((*A)[end], point) <= d) {
        int a = begin - 1;
        int b = end;
        while(a + 1 < b) {
          int mid = (a + b) / 2;


          if (I((*A)[mid], point) <= d) {
            b = mid;
          } else {
            a = mid;
          }
        }

        end = b - 1;
      }
#ifdef DEBUG
      if (help != end){
        cout<<"ERROR : "<<help<<" "<<end<<endl;
      } 
#endif
      } else {

#ifdef DEBUG
      int help = begin;

      while(help<=end && I((*A)[help], point)<= d) {
        help++;
      }
#endif
      if(begin<=end && I((*A)[begin], point) <= d) {
        int a = begin;
        int b = end + 1;

        while (a < b) {
          int mid = (a + b) / 2;

          if (I((*A)[mid], point) <= d) {
            a = mid + 1;
          } else {
            b = mid;
          }
        }
        
        begin = b;
      }
#ifdef DEBUG
      if (help != begin) { 
        cout<<" ERROR 2: "<<help<<" "<<begin<<endl;
        throw "error";
      }
#endif
    }
  }

};

class TwoThirdSet : public Set {

public:

  TwoThirdSet (Point p, vector<Point> *A, int a, int b, bool c): Set(p, A, a, b, c)  { }

 virtual void deleteBigger(double d) {
  if (getSize() == 0) {
    return;
  }
    if (increasing) {
      int pos = (getSize() * 2) / 3;
      double el = getElement(pos);
      
      if (el >= d) {
        end = begin + pos - 1;
      }

      } else {
        int pos = (getSize()) / 3;
        double el = getElement(pos);
        if (el >= d) {
          begin = begin + pos + 1;
        }
    }
  }

  virtual void deleteSmaller(double d) {
    if(getSize() == 0) {
      return;
    }

    if (increasing) {
        int pos = (getSize()) / 3;
        double el = getElement(pos);
        if (el <= d) {
          begin = begin + pos + 1;
        }
    } else {
        int pos = (2 * getSize()) / 3;
        double el = getElement(pos);
        if (el <= d) {
          end = begin + pos - 1;
        }
    }
  }
};

class Solver {

  public:
    void read() {
      scanf("%d", &N);
      for(int n=0; n<N; n++) {
        double a, b;
        scanf("%lf %lf", &a, &b);
        A.push_back(Point(a, b));
        B.push_back(Point(a, b));
      }
    }

    bool epsilonTest(double epsilon, int k) {
      // cout<<"TEST : "<<epsilon<<endl;
      int posA = A.size()-1;
      int posB = B.size()-1;

      while(posB > -1) {
        k--;
        int help = posA;
        while (help > -1 && B[posB].x - A[help].x <= epsilon) {
          help--;
        }

        if (help == posA) {
          // no approximation :(
          return false;
        }

        posA = help+1;

        // cout<<"posA : "<<posA<<endl;

        if (I(A[posA], B[posB]) > epsilon) {
          // no approximation
          return false;
        }

        while(posB > -1 && I(A[posA], B[posB]) <= epsilon) {
          // cout<<"I : "<<I(A[posA],B[posB])<<endl;
          posB--;
        }
      }

      // cout<<" RES : "<<(k >=0 )<<endl;

      return k >= 0;
    }

    template <typename MySet> vector<MySet> createSet() {

      vector<MySet> v;

      int a = -1;
      for(Point pointB : B ) {
        double m = 1;
        double n = pointB.y - pointB.x;

#ifdef DEBUG
        cout<<"F = 1*x + "<<n<<endl;
#endif 
        // TODO : what is with an empty size
        while(a+1 < A.size() && (m*A[a+1].x + n) <= A[a+1].y) {
          a++;          
        }

        v.push_back(MySet(pointB, &A, 0,a, true));
        v.push_back(MySet(pointB, &A, a+1, A.size()-1, false));
      }

      return v;
    }

 template <typename MySet> double fastSolution(int k) {
    vector<MySet> v = createSet<MySet>();

    // TODO : change this to a resonable value
    double best = 1000000;

      int it =0;
      while(true) {
        it++;

        int totalSize = 0;
        for (auto s : v) {
#ifdef DEBUG
          s.print();
          cout<<" SIZE : "<<s.getSize()<<endl;
#endif
          totalSize += s.getSize();
        }

#ifdef DEBUG
        cout<<"TOTALSIZE : "<<totalSize;
#endif
        if (totalSize == 0) {
#ifdef DEBUG
          cout<<" FINISH "<<endl;
#endif
          return best;
        }


        int num = rand() % totalSize;

        // choose element num from the set
        double val = 0;
        for(auto s : v) {
          if (s.getSize() <= num) {
            num -= s.getSize();
          } else {
            val = s.getElement(num);
            break;
          }
        }

#ifdef DEBUG
        cout<<"VAL : "<<val<<endl;
#endif

        if (epsilonTest(val, k)) {
#ifdef DEBUG
          cout<<"  YES " <<val<<endl;
#endif
          if (val < best) {
            best = val;
          } 

          for (int n=0; n<v.size(); n++) {
            v[n].deleteBigger(best);
          }



          // e >= e*
        } else {
#ifdef DEBUG
          cout<<"  NO "<<val<<endl;
#endif
          for (int n=0; n<v.size(); n++) {
            v[n].deleteSmaller(val);
          }
        }
#ifdef DEBUG
        cout<<"FINISHED ROUND"<<endl;
#endif 
      }
    }

    double simpleSolution(bool binarySearch, int k) {

      vector<double> possibleValues;

      for (Point a : A) {
        for( Point b : B) {
          possibleValues.push_back(I(a,b));
        }
      }

      sort(possibleValues.begin(), possibleValues.end());

      int begin = 0;
      int end = possibleValues.size() - 1;

      if (binarySearch) {
        while(begin < end) {
          int mid = (begin + end) / 2;
          if (epsilonTest(possibleValues[mid], k)) {
            end = mid;
          } else {
            begin = mid + 1;
          }
        }

        // cout<<"begin "<<begin<<endl;

        return possibleValues[begin];
      } else {

        for (double dist : possibleValues) {
          // cout<<"DIST : "<<dist<<endl;
          if (epsilonTest(dist, k)) {
            return dist;
          }
        }
      }

      cout<< "This should not happen" <<endl;
      return -1;
    }

    int getSize() {
      return N;
    }

  private:
    int N;
    vector<Point> A;
    vector<Point> B;
};

#define DIVIDE 1000

int main(int argc, char* argv[]) {

if (argc <= 2) {
    cout<<"USAGE ./a.out k [--fast [--twoThird] ] [--simple] [--timeMode] <<INPUT_STREAM"<<endl;
    return 0;
  }

  Solver* solver = new Solver();
  solver->read();

  bool timeMode = false;
  bool fastSolution = false;
  bool simpleSolution = false;
  bool half = false;
  bool twoThird = false;

  for (int n=2; n<argc; n++) {
    if(strcmp(argv[n], "--timeMode") == 0) {
      timeMode = true;
    } else if(strcmp(argv[n], "--simple") == 0) {
      simpleSolution = true;
    } else if(strcmp(argv[n], "--fast") == 0) {
      fastSolution = true;
    } else if(strcmp(argv[n], "--half") == 0) {
      half = true;
    } else if(strcmp(argv[n], "--twoThird") == 0) {
      twoThird = true;
    } else {
      cout<<" UNKNOWN PARAMETER " <<argv[n]<<endl;
    } 
  }

  int k;

  if (half) {
    k = (solver->getSize()) / 2;
  } else {
    k = atoi(argv[1]);
  }

  if (fastSolution) {
    std::clock_t start = std::clock();
    double simple ;

    if (twoThird) {
      simple = solver->fastSolution<TwoThirdSet>(k);
    } else {
      simple = solver->fastSolution<Set>(k);
    }

    double time = (std::clock() - start) / (double)(CLOCKS_PER_SEC / DIVIDE );

    if (timeMode) {
      cout<<solver->getSize()<<" "<<time<<endl;
    } else {
      cout<<"Fast   solution : "<<simple<<endl;
    }
  }

  if (simpleSolution) {
    std::clock_t start = std::clock();
    double simple = solver->simpleSolution(true, k);
    double time = (std::clock() - start) / (double)(CLOCKS_PER_SEC / DIVIDE);

    if (timeMode) {
      cout<<solver->getSize()<<" "<<time<<endl;
    } else {
      cout<<"Simple solution : "<<simple<<endl;
    }

  }
}
