package HyperEps;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class GNUPrinter {
	
	public static void print(ProblemManager manager, boolean isHyp, boolean TTP, String title, String name, String path){
		
		
	  	String header = 	String.format("set terminal postscript eps enhanced color font 'Helvetica,20' linewidth 2\n" +
                "set title '%s' \n" +
                "set style line 1 linecolor rgb '#0060ad' linetype 1 linewidth 5\n" +
                "set style line 2 linecolor rgb '#dd181f' linetype 1 linewidth 5\n" +
                "set style line 3 linecolor rgb '#00bfff' linetype 1 linewidth 5\n" +
                "set style line 4 linecolor rgb '#cdb79e' linetype 1 linewidth 5\n" +
                String.format("set xlabel 'population = %d, generations = %s' \n", manager.getSelectionSize(), manager.getTotalGenerationSize()) +
                "set logscale y  \n" +
                "set logscale x\n", title);

	  	

	  	header += String.format("	   set output '%s.eps' \n", name);
	  	if (TTP ) {
		  	header += String.format("	   set output  'hyp.eps' \n", name);
	  		
	  		header += "set ylabel 'Approx - P ' \n";
	  		header += String.format("plot '%s' using 1:3 title 'before postprocessing' with lines ls 1,"
	  				+ " '%s' using 1:4 title 'after postprocessing' with lines ls 2;",
		  			name, name);
	  	} else if (isHyp) {
	  		header += "set ylabel 'MAXHYP - P ' \n";
	  		
	  		header += String.format("plot '%s' using 1:3 title 'algorithm with postprocesing' with lines ls 2, '%s' using 1:2 title 'algorithm without postprocessing' with lines ls 1;",
		  			name, name);
	  	} else {
	  		header += "set ylabel 'OPTEPS - P ' \n";
	  		header += String.format("plot  '%s' using 1:4 title 'eps without postprocessing (upper)' with lines ls 2, '%s' using 1:3 title 'eps without postprocessing (lower)' with lines ls 1,  '%s' using 1:4 title 'eps with postprocessing (upper)' with lines ls 3, '%s' using 1:5 title 'eps with postprocessing (lower)' with lines ls 4",
	  				name, name, name,name );

	  	
	  	
	  	}
	  	
	  	path = path.replaceAll(".ttp", "");
	  	
	  	System.out.println("Generationg GNU file: " + path);
	  	PrintWriter writer;
		try {
			writer = new PrintWriter(new File(path));		  	
		  	writer.print(header);
		  	writer.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	  	
	  	
	  	
	}

}
