package HyperEps;
import java.io.FileInputStream;
import java.io.IOException;
import java.security.InvalidParameterException;
import java.util.Properties;

import jmetal.core.Algorithm;
import jmetal.core.Problem;
import jmetal.core.SolutionSet;
import jmetal.metaheuristics.ibea.IBEA;
import jmetal.metaheuristics.moead.MOEAD;
import jmetal.metaheuristics.nsgaII.NSGAII;
import jmetal.metaheuristics.smsemoa.SMSEMOA;
import jmetal.metaheuristics.spea2.SPEA2;
import jmetal.problems.DTLZ.DTLZ1;
import jmetal.problems.DTLZ.DTLZ2;
import jmetal.problems.DTLZ.DTLZ7;
import jmetal.problems.WFG.WFG1;
import jmetal.problems.WFG.WFG2;
import jmetal.problems.WFG.WFG3;
import jmetal.problems.WFG.WFG4;
import jmetal.problems.ZDT.ZDT1;
import jmetal.problems.ZDT.ZDT2;
import jmetal.problems.ZDT.ZDT3;
import jmetal.problems.ZDT.ZDT6;
import jmetal.util.JMException;


public class MyExperiments {




  public static void main(String[] args) throws ClassNotFoundException, JMException {

    MyConfiguration config = new MyConfiguration("configBenchmarks/" + args[0]);
    Problem problem = config.getProblem();

    Algorithm alg = config.getAlgorithm(problem);

    ProblemManager myproblem = new ProblemManager(problem, config);

    Algorithm algorithm = config.getAlgorithm(myproblem);

    AlgorithmManager myAlgorithm =  new AlgorithmManager(myproblem, problem, algorithm, config);

    System.out.println("Start the algorithm");
    long initTime = System.currentTimeMillis();
    algorithm.execute();
    long estimatedTime = System.currentTimeMillis() - initTime;

    myproblem.closeAndWriteGNUPLOT();

    System.out.println("Algorithm finished");

  }

}
