package HyperEps;

import jmetal.core.Algorithm;
import jmetal.core.Problem;
import jmetal.util.JMException;

public class MyRestart {
	
public static void main(String[] args) throws ClassNotFoundException, JMException {
		
		 MyConfiguration config = new MyConfiguration("configRestart/" + args[0]);

		    Problem problem = config.getProblem();

		    Algorithm alg = config.getAlgorithm(problem);

		    ProblemManager myproblem = new ProblemManager(problem, config);

		    int restarts = Integer.parseInt(config.getProperty("restartRate"));
		    
		    for(int n=0; n<restarts; n++) {
			    Algorithm algorithm = config.getAlgorithm(myproblem);
	
			    AlgorithmManager myAlgorithm =  new AlgorithmManager(myproblem, problem, algorithm, config);
	
			    System.out.println("Start the algorithm");
			    long initTime = System.currentTimeMillis();
			    algorithm.execute();
			    long estimatedTime = System.currentTimeMillis() - initTime;
			    
			    myproblem.addEvaluationRound();
		    }
		    myproblem.closeAndWriteGNUPLOT();
		    

		    System.out.println("Algorithm finished");

}
	
}
