package HyperEps;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import jmetal.core.Algorithm;
import jmetal.core.Problem;
import jmetal.metaheuristics.ibea.IBEA;
import jmetal.metaheuristics.nsgaII.NSGAII;
import jmetal.metaheuristics.smsemoa.SMSEMOA;
import jmetal.metaheuristics.spea2.SPEA2;
import jmetal.problems.DTLZ.DTLZ1;
import jmetal.problems.DTLZ.DTLZ2;
import jmetal.problems.ZDT.ZDT1;
import jmetal.problems.ZDT.ZDT2;
import jmetal.util.JMException;

public class MyTTP {

	public static void main(String[] args) throws ClassNotFoundException,
			JMException {

		String path = System.getProperty("user.home") + "/hypselection/ttp/";
		path = path + "a280-10.ttp"; // "a28hyp0.ttp";
		Problem problem = new TTPProblem(path);

	

		Algorithm algo[] = { new NSGAII(problem) };

		for (Algorithm alg : algo) {

			String[] s = alg.getClass().toString().split("\\.");
			String name = s[s.length - 1];
			

			String current = System.getProperty("user.home") + "/hypselection/experiments/";	
		    String configFile = current + "configTTP/" +args[0];
			

			Properties config = new Properties();
			try {
				config.load(new FileInputStream(configFile));
			} catch (IOException e) {
				e.printStackTrace();
				System.err.println("Failed to load configuration file!");
				System.exit(-1);
			}
			
			int popSize = Integer.parseInt(config.getProperty("PopulationSize"));
			int maxEvals = Integer.parseInt(config.getProperty("MaxEvaluations"));
			
			ProblemManager myproblem = new ProblemManager(problem,
					maxEvals, popSize, name);

			Algorithm algorithm;
			algorithm = new NSGAII(myproblem);


			
			AlgorithmManager myAlgorithm = new AlgorithmManager(myproblem,
					problem, algorithm, config);

			System.out.println("Start the algorithm");
			long initTime = System.currentTimeMillis();
			algorithm.execute();
			long estimatedTime = System.currentTimeMillis() - initTime;

			myproblem.closeAndWriteGNUPLOT();

			System.out.println("Algorithm finished");
		}

	}
}
