package HyperEps;

import java.util.HashMap;

import jmetal.operators.crossover.Crossover;
import jmetal.operators.crossover.HUXCrossover;
import jmetal.operators.crossover.PMXCrossover;
import jmetal.operators.crossover.SBXCrossover;
import jmetal.util.JMException;

public class TTPCrossover extends Crossover {

  PMXCrossover permCrossover;
  HUXCrossover huxCrossover;
	
  public TTPCrossover(double prob1, double prob2, HashMap<String, Object> parameters) {
    super(parameters);
    
    HashMap p = new HashMap();
	p.put("probability", prob1) ;
	parameters.put("distributionIndex", 20.0) ;
	
    permCrossover = new PMXCrossover(parameters);
    
    p = new HashMap();
	parameters.put("probability", prob2) ;
    huxCrossover = new HUXCrossover(parameters);
  }

  @Override
    public Object execute(Object object) throws JMException {
      // 1. do the Permutation crossOver
      Object ret = permCrossover.execute(object);
      ret = huxCrossover.execute(object);
      
      return ret;
    }

}
