package HyperEps;
import jmetal.core.Problem;
import jmetal.core.SolutionType;
import jmetal.core.Variable;
import jmetal.encodings.variable.ArrayInt;
import jmetal.encodings.variable.Binary;
import jmetal.encodings.variable.Permutation;



public class TTPSolutionType extends SolutionType {

	private final int cityCount;
	private final int itemCount;
	
	public TTPSolutionType(Problem problem, 
			int numberOfCities,
			int numberOfItems
			) {
		super(problem);
		
		cityCount = numberOfCities;
		itemCount = numberOfItems;
	}	

	@Override
	public Variable[] createVariables() throws ClassNotFoundException {
		Variable [] variables = new Variable[2];
		
	    variables[0] = new Permutation(cityCount);
	    
	    // if we can take item {0,1,2} the limit will be 0 <= 3
	    variables[1] = new Binary(itemCount);; 
	    return variables ;
	}
}
