set terminal postscript eps enhanced color font 'Helvetica,20' linewidth 2
set output 'spea.eps'

set title "Spe procesing"

set style line 1 linecolor rgb '#0060ad' linetype 1 linewidth 5
set style line 2 linecolor rgb '#dd181f' linetype 1 linewidth 5
set style line 3 linecolor rgb '#00bfff' linetype 1 linewidth 5
set style line 4 linecolor rgb '#cdb79e' linetype 1 linewidth 5

set xlabel "population = 100, maxEvaluation = N" 
set ylabel "MAXHYP - P "

set logscale y
set logscale x

plot 'spea.data' using 1:3 title 'algorithm with postprocesing' with lines ls 2, 'spea.data' using 1:2 title 'algorithm without postprocessing' with lines ls 1;

set title "NSGAII processing"


set output 'nsgaii.eps'

plot 'nsga.data' using 1:3 title 'algorithm with postprocesing' with lines ls 2, 'nsga.data' using 1:2 title 'algorithm without postprocessing' with lines ls 1;

set output 'nsga-convergence.eps' 

plot 'nsga-convergence.data' using 1:2 title 'random convergence' with lines ls 1,'nsga.data' using 1:3 title 'algorithm with postprocesing' with lines ls 2;

set output 'nsga-10.eps'

plot 'nsga-10.data' using 1:3 title 'algorithm with postprocesing' with lines ls 2, 'nsga-10.data' using 1:2 title 'algorithm without postprocessing' with lines ls 1;


set output 'nsga-diff.eps'

set title "NSGAII difference from both algorith"
set ylabel "difference "

plot 'nsga-diff.data' every 10 using 1:4 title 'difference between post and preprocessing' with lines ls 2 ;

set title "SMS-EMOA difference from both algorith"
set output 'sms-emoa-diff.eps' 
plot 'sms-emoa.data'  using 1:4 title 'difference between post and preprocessing' with lines ls 2 ;


set title "SMS-EMOA : improvement of post-processing"
set ylabel "MAXHYP-P"

set output 'sms-emoa.eps' 
plot 'sms-emoa.data'  using 1:3 title 'algorithm with postprocesing' with lines ls 2, 'sms-emoa.data'  using 1:2 title 'algorithm without postprocesing' with lines ls 1 ;

set output 'ns-sms.eps'
set key bottom left
plot 'ns.data' using 1:3 title 'nsa with postprocessing' with lines ls 2, 'ns.data' using 1:2 title 'nsa without postprocessing' with lines ls 1, 'sms.data' using 1:3 title 'sms with postprocessing' with lines ls 4, 'sms.data' using 1:2 title 'sms without postprocessing' with lines ls 3

set output 'zd1-ns-sms.eps'
set key bottom left
set title "Testing on ZD1"
plot  'zd1-sm.data' using 1:3 title 'sms with postprocessing' with lines ls 4, 'zd1-sm.data' using 1:2 title 'sms without postprocessing' with lines ls 3, 'zd1-ns.data' using 1:3 title 'nsa with postprocessing' with lines ls 2, 'zd1-ns.data' using 1:2 title 'nsa without postprocessing' with lines ls 1



set output 'zd3-ns-sms.eps'
set key bottom left
set title "Testing on ZD3"
plot  'zd3-sm.data' using 1:3 title 'sms with postprocessing' with lines ls 4, 'zd3-sm.data' using 1:2 title 'sms without postprocessing' with lines ls 3, 'zd3-ns.data' using 1:3 title 'nsa with postprocessing' with lines ls 2, 'zd3-ns.data' using 1:2 title 'nsa without postprocessing' with lines ls 1


set output 'eps.eps'
set ylabel "P - optEps"


set title "Testing Eps on NSGAII (DTLZ1)"
plot  'eps.data' using 1:2 title 'eps without postprocessing (upper)' with lines ls 2, \
      'eps.data' using 1:3 title 'eps without postprocessing (lower)' with lines ls 1, \
      'eps.data' using 1:4 title 'eps with postprocessing (upper)' with lines ls 3, \
      'eps.data' using 1:5 title 'eps with postprocessing (lower)' with lines ls 4


set output 'dtlz2.eps'
set title "Testing Eps on NSGAII (DTLZ2)"
plot  'dtlz2.data' using 1:2 title 'eps without postprocessing (upper)' with lines ls 2, \
      'dtlz2.data' using 1:3 title 'eps without postprocessing (lower)' with lines ls 1, \
      'dtlz2.data' using 1:4 title 'eps with postprocessing (upper)' with lines ls 3, \
      'dtlz2.data' using 1:5 title 'eps with postprocessing (lower)' with lines ls 4
