import math
import random
import sys
import os

def genTestCase(function, begin, end, elements, fileName, equal, count):
  print("%s Generate %s" % (count,fileName))
  f = open(fileName, 'w')
  f.write("%s\n" % elements)

  if (equal) :
    steps = (1.0 * (end - begin)) / elements

    for i in range(elements):
      x = begin + steps * i
      f.write("%s %s\n" % (x, function(x)) )

  else:
    arr = range(elements)
    for i in range(elements):
      arr[i] = random.uniform(begin, end)
    arr.sort()

    for i in range(elements):
      x = round(arr[i], 4)
      f.write("%s %s\n" % (x, function(x)) )

  f.close()
  print("FINISHED %s " % fileName)

def genTest(A, elements, testName, equal, count):
  genTestCase(A[0], A[1], A[2], elements, testName, equal, count)

print("Start generator")
f1 = (lambda x : 1.0 - x, 0.0, 1.0)
f2 = (lambda x : 1.0 / x, 0.01, 100.0)
f3 = (lambda x : math.sqrt(1 - x**2), 0.0, 1.0) 

os.system('rm *data');

timeout = 10

for i in range(1,101):
  num = int(10 ** (7 * (i/100.0)))
  if num > 9:
    fileName = '%s' % num
    genTest(f2, num, fileName, True, i)
    for k in [10,20,50]:
      os.system('timeout %s ../epsilon %s --simple --timeMode <%s >>eps-simple-%s.data' % (timeout,k,fileName, k) )
      os.system('timeout %s ../epsilon %s --fast --timeMode <%s >>eps-fast-%s.data' % (timeout,k, fileName, k) )
      os.system('timeout %s ../epsilon %s --fast --twoThird --timeMode <%s >>eps-twoThird-%s.data' % (timeout,k,fileName, k))
      os.system('timeout %s ../hyp %s --dp --timeMode <%s >>hyp-simple-%s.data' % (timeout,k, fileName, k))
      os.system('timeout %s ../hyp %s --fast --timeMode <%s >>hyp-fast-%s.data' % (timeout,k, fileName, k))

    k = num/2
    os.system('timeout %s ../epsilon %s --simple --timeMode <%s >>eps-simple-%s.data' % (timeout,k,fileName, "half"))
    os.system('timeout %s ../epsilon %s --fast --timeMode <%s >>eps-fast-%s.data' % (timeout,k, fileName, "half"))
    os.system('timeout %s ../epsilon %s --fast --twoThird --timeMode <%s >>eps-twoThird-%s.data' % (timeout,k,fileName, "half"))
    os.system('timeout %s ../hyp %s --dp --timeMode <%s >>hyp-simple-%s.data' % (timeout,k, fileName, "half"))
    os.system('timeout %s ../hyp %s --fast --timeMode <%s >>hyp-fast-%s.data' % (timeout,k, fileName, "half"))



    os.system('rm %s' % fileName)

